require "redk/capn_panda/version"
require 'colorize'
require 'git'
require 'gerry'
require 'jira'
require 'keychain'
require 'thor'
require 'word_wrap'


require "redk/capn_panda/config"
require "redk/capn_panda/cli"
require "redk/capn_panda/gerrit"
require "redk/capn_panda/jira_client"

module Redk
  module CapnPanda
    class KeyChainError < StandardError
    end

    def self.config
      @config ||= Config.load
    end

    def self.git
      @git ||= Git.open(Dir.pwd)
    end

    def self.gerrit
      @gerrit ||= Gerrit.from_keychain
    end

    def self.jira
      @jira ||= JiraClient.from_keychain
    end
  end
end


Git::Branches.class_eval do
  def local
    @local ||= self.select { |b| !b.remote }
  end
end


module Git::Base::Factory

  # returns a Git::Branches object of all the Git::Branch
  # objects for this repo
  def branches
    @branches ||= Git::Branches.new(self)
  end
end
