module Redk::CapnPanda

  class Gerrit < Gerry::Client

    def self.gerrit_domain
      Redk::CapnPanda.config.gerrit_domain
    end

    def self.from_keychain
      @keychain_client ||= (
        keychain_item = Keychain.default.internet_passwords.where(server: self.gerrit_domain).first
        raise Redk::CapnPanda::KeyChainError, "#{self.gerrit_domain} is in your keychain" unless keychain_item
        self.from_keychain_item(keychain_item) if keychain_item
      )
    end

    def self.from_keychain_item(keychain_item)
      self.new("https://#{self.gerrit_domain}", keychain_item.account, keychain_item.password)
    end


    def my_changes
      @my_changes ||= self.changes(['q=is:open+owner:self', 'o=LABELS'])
    end

  end
end
